#include "jserver.h"

xmlnode mod_basic_config = NULL;

int mod_basic_auth(char *user, char *pass)
{
    xmlnode next;

    printf("MOD_BASIC: user[%s] pass[%s]\n",user,pass);
    next = xmlnode_get_firstchild(mod_basic_config);
    while(next != NULL)
    {
        if(xmlnode_get_type(next) == NTYPE_TAG && j_strcmp(xmlnode_get_name(next),"user") == 0)
        {
            if(j_strcmp(user, xmlnode_get_attrib(next, "name")) == 0 && j_strcmp(pass, xmlnode_get_attrib(next, "pass")) == 0)
                return TRUE;
        }
        next = xmlnode_get_nextsibling(next);
    }

    return FALSE;
}

int dispatch(mapi m)
{
    xmlnode x;

    debug("mod_basic");

    switch(m.phase)
    {
        case M_PHASE_CONFIG:
            printf("MOD_BASIC: config %s\n",xmlnode2str(m.pkt->x));
            mod_basic_config = xmlnode_dup(m.pkt->x);
            break;
        case M_PHASE_AUTH:
            printf("MOD_BASIC: auth %s\n",xmlnode2str(m.pkt->x));
            x = xmlnode_get_tag(m.pkt->x,"query");
            if(mod_basic_auth(xmlnode_get_data(xmlnode_get_firstchild(xmlnode_get_tag(x, "user"))),
                              xmlnode_get_data(xmlnode_get_firstchild(xmlnode_get_tag(x, "pass")))))
            {
                /* XXX modify the iq packet correctly to signify the auth success */
                jid_set(m.pkt->from, xmlnode_get_data(xmlnode_get_firstchild(xmlnode_get_tag(x, "user"))), JID_USER);
                jid_set(m.pkt->from, xmlnode_get_data(xmlnode_get_firstchild(xmlnode_get_tag(x, "resource"))), JID_RESOURCE);
                m.pkt->flag = JP_FLAG_AUTHOK;
            }else{
                /* XXX modify the iq packet correctly to signify the auth failure */
            }
            break;
        default:
            printf("MOD_BASIC: unknown phase %d\n",m.phase);
    }
    return M_FLAG_OK;
}

