#include "jserver.h"

void etherx_receive(epacket e, int flag)
{
    /* handles incoming packets from etherx */

    switch(flag)
    {
        case EPACKET_NORMAL:
            printf("EXTERNAL: got epacket from[%s]: %s\n",e->from, xmlnode2str(e->x));
            break;
        case EPACKET_REGISTRY:
            config_handle(e->x);
            break;
        case EPACKET_INIT:
            config_startup();
            break;
    }
}

void *external_main(void *arg)
{
    /* thread that waits for messages intended to be sent externally, calls etherx_write */
    /* service phase for externally bound packets? */
    /* use transports and jid->type, deliver to transport for type */
    pth_event_t ev;
    pth_msgport_t mp;
    jpq q;
    
    debug("THREAD:EXTERNAL starting");

    mp = pth_msgport_create("external");
    ev = pth_event(PTH_EVENT_MSG,mp);

    while(1)
    {
        pth_wait(ev);
        while((q = (jpq)pth_msgport_get(mp)) != NULL)
        {
            debug("THREAD:EXTERNAL received a message!");
            /* use module API to handle these or bounce them to the p->from */
        }
    }
    
    pth_event_free(ev,PTH_FREE_ALL);
    pth_msgport_destroy(mp);
}
